VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "ShowFont"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' ***** CD - Common Dialog SHOW FONT *****
' By Claudio Gucchierato 02/2001 - Vers. 1.1

Option Explicit

Private Declare Function ChooseFont Lib "comdlg32.dll" Alias "ChooseFontA" (pChoosefont As ChooseFont) As Long
Private Declare Function CreateFontIndirect Lib "gdi32" Alias "CreateFontIndirectA" (lpLogFont As LOGFONT) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function GetTextFace Lib "gdi32" Alias "GetTextFaceA" (ByVal hdc As Long, ByVal nCount As Long, ByVal lpFacename As String) As Long
Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long
Private Declare Function GetDC Lib "user32" (ByVal hOwner As Long) As Long
Private Declare Function lstrcpy Lib "kernel32" Alias "lstrcpyA" (p1 As Any, p2 As Any) As Long
Const LF_FACESIZE = 32
Private Type LOGFONT
    lfHeight As Long
    lfWidth As Long
    lfEscapement As Long
    lfOrientation As Long
    lfWeight As Long
    lfItalic As Byte
    lfUnderline As Byte
    lfStrikeOut As Byte
    lfCharSet As Byte
    lfOutPrecision As Byte
    lfClipPrecision As Byte
    lfQuality As Byte
    lfPitchAndFamily As Byte
    lfFaceName(LF_FACESIZE) As Byte
End Type

Private Type ChooseFont
    lStructSize As Long
    hwndOwner As Long
    hdc As Long
    lpLogFont As Long
    iPointSize As Long
    flags As Long
    rgbColors As Long
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
    hInstance As Long
    lpszStyle As String
    nFontType As Integer
    MISSING_ALIGNMENT As Integer
    nSizeMin As Long
    nSizeMax As Long
End Type

Const CF_INITTOLOGFONTSTRUCT = &H40&
Const SCREEN_FONTTYPE = &H2000
Const BOLD_FONTTYPE = &H100
Const FW_BOLD = 700
Const LOGPIXELSY = 90
 
'flags
Private Enum FFlags
  cdlCFScreenFonts = &H1  'vengono visualizzati solo i caratteri supportati dallo schermo
  cdlCFPrinterFonts = &H2 'visualizza solo i caratteri supportati dalla stampante e specificati dalla propriet hDC
  cdlCFBoth = &H3 ' visualizza i font di stampa per lo schermo (hDC identifica il contesto della periferica associato alla stampante)
  cdlCFHelpButton = &H4 'visualizza il pulsante guida (?)
  cdlCFEffects = &H100  'visualizza la sezione che permette di modificare gli effetti: barrato, sottolineato e colore
  cdlCFApply = &H200  'visualizza il pulsante applica
  cdlCFANSIOnly = &H400 'non vengono visualizzati i font a base di simboli
  cdlCFNoVectorFont = &H800 'disabilita la possibilit di selezionare caratteri di tipo vettoriale
  cdlCFNoSimulations = &H1000 'disabilita l'emulazione dei caratteri della GDI (Graphic Device Interface)
  cdlCFLimitSize = &H2000 'dimensioni dei font definite dalla propriet nSizeMin e nSizeMax
  cdlCFFixedPitchOnly = &H4000 'visualizza solo i caratteri a dimensione fissa
  cdlCFWYSIWYG = &H8000 'permette di selezionare la sezione di tipi di carattere per la stampante e per lo schermo
  cdlCFForceFontExist = &H10000 'visualizza una finestra di messaggio di errore se non viene selezionato un carattere o uno stile inesistente
  cdlCFScalableOnly = &H20000 'permette di selezionare solo i caratteri scalabili
  cdlCFTTOnly = &H40000  'visualizza solo i caratteri TrueType
  cdlCFNoFaceSel = &H80000 'non viene selezionato nessun nome di carattere predefinito
  cdlCFNoStyleSel = &H100000 'non viene selezionato nessuno stle di caratteri come predefinito
  cdlCFNoSizeSel = &H200000 'non viene seleziona nessuna dimensione di carattere come predefinita
 End Enum
 'Note:
 'il flag cdlCFWYSIWYG deve essere usato solo in combinazione con i flags:
 'cdlCFScreenFonts  cdlCFPrinterFonts. Se viene impostato il flag cdlCFWYSIWYG
 'occorre impostare anche i flags: cdlCFBoth e cdlCFScalableOnly

Private mhOwner As Long
Private mRGBResult As Long
Private mItalic As Boolean
Private mUnderline As Boolean
Private mStrikethru As Boolean
Private mFontName As String
Private mFontSize As Long
Private mBold As Boolean
Private mAnnulla As Boolean

Public Property Get FontAnnulla() As Boolean
   FontAnnulla = mAnnulla
End Property
Public Property Get Bold() As Boolean
  Bold = mBold
End Property
Public Property Let Bold(bBold As Boolean)
   mBold = bBold
End Property
Public Property Get FontName() As String
   FontName = mFontName
End Property
Public Property Let hOwner(ByVal New_hOwner As Long)
    mhOwner = New_hOwner
End Property

Public Property Let FontName(sName As String)
   mFontName = sName
End Property
Public Property Get FontSize() As Long
  FontSize = mFontSize
End Property
Public Property Let FontSize(lSize As Long)
   mFontSize = lSize
End Property

Public Property Get Italic() As Boolean
  Italic = mItalic
End Property
Public Property Let Italic(BItalic As Boolean)
   mItalic = BItalic
End Property
Public Property Get StrikeThru() As Boolean
   StrikeThru = mStrikethru
End Property
Public Property Let StrikeThru(bStrikethru As Boolean)
   mStrikethru = bStrikethru
End Property
Public Property Get Underline() As Boolean
   Underline = mUnderline
End Property
Public Property Let Underline(bUnderline As Boolean)
   mUnderline = bUnderline
End Property
Public Property Get DefaultExt() As String
   DefaultExt = mDefaultExt
End Property

Public Property Let DefaultExt(sDefExt As String)
   mDefaultExt = DefaultExt
End Property
Public Property Get FileName() As String
   FileName = mFileName
End Property
Public Property Let FileName(sFileName As String)
   mFileName = sFileName
End Property
Public Property Get RGBResult() As Long
   RGBResult = mRGBResult
End Property
Public Property Let RGBResult(lValue As Long)
   mRGBResult = lValue
End Property

Public Sub ShowFont()
  On Error GoTo FontError
  Dim CF As ChooseFont
  Dim LF As LOGFONT
  Dim TempByteArray() As Byte
  Dim ByteArrayLimit As Long
  Dim OldhDC As Long
  Dim FontToUse As Long
  Dim tbuf As String * 80
  Dim x As Long
  Dim RetValue As Long
  TempByteArray = StrConv(mFontName & vbNullChar, vbFromUnicode)
  ByteArrayLimit = UBound(TempByteArray)
  With LF
     For x = 0 To ByteArrayLimit
        .lfFaceName(x) = TempByteArray(x)
     Next
    .lfHeight = mFontSize / 72 * GetDeviceCaps(GetDC(mhOwner), LOGPIXELSY)
    .lfItalic = mItalic * -1
    .lfUnderline = mUnderline * -1
    .lfStrikeOut = mStrikethru * -1
    If mBold Then .lfWeight = FW_BOLD
  End With
  
  With CF
      .lStructSize = Len(CF)
      .hwndOwner = mhOwner
      .hdc = GetDC(mhOwner)
      .lpLogFont = lstrcpy(LF, LF)
'flags
     .flags = CF_INITTOLOGFONTSTRUCT
     .flags = .flags Or FFlags.cdlCFScreenFonts
     .flags = .flags Or FFlags.cdlCFEffects
     .flags = .flags Or FFlags.cdlCFForceFontExist
     '.flags = .flags Or FFlags.'aggiungere eventuali altri flags
     .rgbColors = mRGBResult
     .lCustData = 0
     .lpfnHook = 0
     .lpTemplateName = 0
     .hInstance = 0
     .lpszStyle = 0
     .nFontType = SCREEN_FONTTYPE
     .nSizeMin = 0 'con il flag cdlCFLimitSize impostare il valore voluto
     .nSizeMax = 0 'con il flag cdlCFLimitSize impostare il valore voluto
     .iPointSize = mFontSize * 10
  End With
    
  RetValue = ChooseFont(CF)
   If RetValue = 0 Then
       mAnnulla = True 'premuto il tasto annulla
   Else
      mAnnulla = False
      mItalic = LF.lfItalic * -1
      Underline = LF.lfUnderline * -1
       mStrikethru = LF.lfStrikeOut * -1
       
       With CF
            mFontSize = .iPointSize \ 10
            mRGBResult = .rgbColors
              If .nFontType And BOLD_FONTTYPE Then
                  mBold = True
               Else
                  mBold = False
               End If
       End With
       
       FontToUse = CreateFontIndirect(LF)
         If FontToUse = 0 Then Exit Sub
         OldhDC = SelectObject(CF.hdc, FontToUse)
         RetValue = GetTextFace(CF.hdc, 79, tbuf)
         mFontName = Mid$(tbuf, 1, RetValue)
   End If
Exit Sub
FontError:
   mAnnulla = True
End Sub

Private Sub Class_Initialize() 'Default value
   mRGBResult = 0
   mItalic = False
   mUnderline = False
   mStrikethru = False
   mFontName = "Arial"
   mFontSize = 8
   mBold = False
End Sub
